var cons, extname, loaderUtils;

cons = require('consolidate');

loaderUtils = require('loader-utils');

extname = require('path').extname;

module.exports = function(content) {
  var callback, key, opt, vue;
  this.cacheable && this.cacheable();
  callback = this.async();
  opt = loaderUtils.parseQuery(this.query);
  vue = this.options.vue;
  if (vue && vue.template) {
    for (key in vue.template) {
      opt[key] = vue.template[key];
    }
  }
  function exportContent(content) {
    if (opt.raw) {
      return callback(null, content);
    } else {
      return callback(null, 'module.exports = ' + JSON.stringify(content));
    }
  };
  if (!opt.engine) {
    opt.engine = extname(this.request).substr(1).toLowerCase();
  }
  if (!cons[opt.engine]) {
    return callback(new Error('Template engine \'' + opt.engine + '\' ' + 'isn\'t available in consolidate.js'));
  }
  opt.filename = this.resourcePath;
  return cons[opt.engine].render(content, opt, function(err, html) {
    if (err) {
      return callback(err);
    } else {
      return exportContent(html);
    }
  });
};
