var loaderUtils, parse5;

parse5 = require('parse5');

loaderUtils = require('loader-utils');

function walk(tree, fn) {
  if (tree.childNodes) {
    return tree.childNodes.forEach(function(node) {
      var isTemplate;
      isTemplate = node.tagName === 'template';
      if (!isTemplate) {
        fn(node);
      }
      if (isTemplate && node.content) {
        return walk(node.content, fn);
      } else {
        return walk(node, fn);
      }
    });
  }
};

module.exports = function(html) {
  var id, query, tree;
  this.cacheable();
  query = loaderUtils.parseQuery(this.query);
  id = query.id;
  tree = parse5.parseFragment(html);
  walk(tree, function(node) {
    if (node.attrs) {
      return node.attrs.push({
        name: id,
        value: ''
      });
    }
  });
  return parse5.serialize(tree);
};
